<template>
  <div class="flex-grow-1 flex-row" v-bind:class="displayClass">
    <div class="skewt-container" ref="skewt"></div>
  </div>
</template>

<script>
// Utilities
import { findParentComponentByName } from '@/core/util'
import { skewT } from '@/core/skewt'

// Mixins
import ParentWorkspaceMixin from '@/dashboard/mixins/ParentWorkspace'
import MomentMixin from '@/core/mixins/moment'

export default {
  name: 'skewtpanel',

  mixins: [
    ParentWorkspaceMixin,
    MomentMixin,
  ],

  props: {
    name: {
      type: String,
      required: true,
    },
  },

  data() {
    return {
      plotter: null,
      loading: true,
      error: null,
    }
  },

  computed: {
    queryPanel: {
      get() {
        return findParentComponentByName(this.$parent, 'querypanel')
      }
    },

    displayClass: {
      get() {
        return this.queryPanel.currentPanel === this.name ? 'd-flex' : 'd-none'
      },
    },
  },

  watch: {
    displayClass(after) {
      if(after === 'd-flex')
        this.$nextTick(() => {
          this.plotter = skewT(this.$refs.skewt)
        })
    },
  },
}
</script>

<style>
.skewt-container {
  height: 40vh;
  width: 40vh;
}

.gridline {
  stroke: #bfbfbf;
  stroke-width: 0.75px;
  fill: none;
}

.tempzero {
  stroke: #aaa;
  stroke-width: 1.25px;
}

.temp {
  fill: none;
  stroke: red;
  stroke-width: 3px;
}

.dwpt {
  fill: none;
  stroke: green;
  stroke-width: 3px;
}

.overlay {
  fill: none;
  pointer-events: all;
}

.focus.tmpc circle {
  fill: red;
  stroke: none;
}

.focus.dwpt circle {
  fill: green;
  stroke: none;
}

.focus text {
  font-size: 12px;
}

.focus.dwpt text {
  text-anchor: end;
}
</style>
